/*////////////////////////////////////////////////////////////////////////
Copyright (c) 1993 Electrotechnical Laboratry (ETL)

Permission to use, copy, modify, and distribute this material 
for any purpose and without fee is hereby granted, provided 
that the above copyright notice and this permission notice 
appear in all copies, and that the name of ETL not be 
used in advertising or publicity pertaining to this 
material without the specific, prior written permission 
of an authorized representative of ETL.
ETL MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY 
OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", 
WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.
/////////////////////////////////////////////////////////////////////////
Content-Type:	program/C; charset=US-ASCII
Program:
Author:		Yutaka Sato <ysato@etl.go.jp>
Description:
History:
///////////////////////////////////////////////////////////////////////*/
#include <stdio.h>
FILE *open_article();

int nbench = 2;
int b_LINKED;
int b_LOCAL;
int b_XMIME;
int b_XNNTP;
int b_DIRECT;

FILE *to_server,*from_server;

char XNNTP_PORT[256] = "SERVICE_nntp=2005/tcp";

char request[1024];
char response[1024];
char cur_group[256];

PUT_server(str){
	int rcode;
	if( b_LOCAL ){
		rcode = fputs(str,to_server);
		fputs("\r\n",to_server);
		fflush(to_server);
	}else{
		rcode = put_server(str);
	}
	return rcode;
}
GET_server(str,len){
	int rcode;
	char *p;

	if( b_LOCAL ){
		rcode = (int)fgets(str,len,from_server);
		if( p = (char*)index(str,'\r') )
			*p = 0;
		if( p = (char*)index(str,'\n') )
			*p = 0;
		return (rcode == NULL) ? -1 : 0;
	}else	return get_server(str,len);
}
server_INIT(machine){
	int to[2],from[2];
	char msg[1024],resp[1024];
	int rcode;

	if( b_LOCAL ){
		pipe(to);
		pipe(from);
		if( fork() == 0 ){
			close(to[1]);  close(0); dup(to[0]);  close(to[0]);
			close(from[0]);close(1); dup(from[1]);close(from[1]);
			execlp("xnntpd","xnntpd",0);
			exit(-1);
		}else{
			to_server = fdopen(to[1],"w");
			from_server = fdopen(from[0],"r");
			if( to_server == NULL || from_server == NULL ){
				printf("cannot connect to the server.\n");
				exit(1);
			}
			close(to[0]);
			close(from[1]);
		}
		GET_server(msg,sizeof(msg));
		printf("%s\n",msg);
	}else{
		rcode = nntp_server_init(machine,resp);
		if( 0 < rcode){
			printf("%s\n",resp);
			if( b_XMIME ){
				PUT_server("XMIME enable");
				GET_server(msg,sizeof(msg));
				printf("%s\n",msg);
			}
		}
		return rcode;
	}
}

send_head_command(group,anum)
{
	if( strcmp(cur_group,group) == 0 ){
		if( b_XNNTP )
			sprintf(request,"XHEAD %d",anum);
		else	sprintf(request,"HEAD %d",anum);
	}else{
		if( b_XNNTP )
			sprintf(request,"XHEAD %s:%d",group,anum);
		else{
			sprintf(request,"GROUP %s",group);
			PUT_server(request);
			GET_server(response,sizeof(response));
			printf("%s\n",response);
			sprintf(request,"HEAD %d",anum);
		}
		strcpy(cur_group,group);
	}
	PUT_server(request);
}

	char *server;
	char group[256];
	int anum1,anum2,inc;
	int anum;

	int start;
	int ok=0,no=0;
	int bytes = 0;

main(ac,av)
	char *av[];
{	int ai;
	char *os;

	if( ac <= 1 ){
		printf("Usage: %s -{dlmsx} group:N1-N2\n",av[0]);
		printf("     -d            direct access to spool\n");
		printf("     -l            local\n");
		printf("     -s            static linked version\n");
		printf("     -m            XMIME\n");
		printf("     -x            XNNTP\n");
		printf("     -h            hostname of xnntpd\n");
		printf("     group:N1-N2   \n");
		exit(0);
	}

	if( server = (char*)getenv("XNNTPSERVER") )
		;
	else	server = "etlss2";
	strcpy(group,"etl.mail-lists.vin");
	anum1 = 1;
	anum2 = 1000;
	inc = 1;

	for( ai = 1; ai < ac; ai++ ){
		if( av[ai][0] == '-' ){
			for( os = &av[ai][1]; *os; os++ )
			switch( *os ){
				case 'd': b_DIRECT = 1; break;
				case 'l': b_LOCAL  = 1; b_XNNTP = 1; break;
				case 'm': b_XMIME  = 1; break;
				case 's': b_LINKED = 1; break;
				case 'x': b_XNNTP  = 1; break;
			}
			continue;
		}
		{	char gn[128];
			int ni,a1,a2;

			ni = sscanf(av[ai],"%[^:]:%d-%d",gn,&a1,&a2);
			if( ni == 3 ){
				strcpy(group,gn);
				anum1 = a1;
				anum2 = a2;
				if( anum1 > anum2 )
					inc = -1;
			}else{
				printf("bench: arg form ? %s\n",av[ai]);
			}
		}
	}
	printf("==== %s:%d-%d\n",group,anum1,anum2);

	if( b_DIRECT )
		printf("[DIRECT] ");
	else
	if( b_XNNTP ){
		printf("[XNNTP] ");
		putenv(XNNTP_PORT);
	}else	printf("[NNTP] ");
	if( b_LOCAL )
		printf("[LOCAL] ");
	else	printf("[REMOTE] ");

	if( b_LINKED ){
		printf("[STATIC-LINKED] ");
		init_nhc();
	}
	printf("\n");

	if( !b_LINKED ){
		if( server_INIT(server) < 0 ){
			printf("failed: serve_init(%s)\n",server);
			exit(1);
		}
		send_head_command(group,anum1);
	}

	{
		int start = time(0);
		int elaps;
		int n;

		for( n = 0; n < nbench; n++ )
			bench(ac,av);

		elaps = time(0) - start;
		if( elaps )
		printf(">>>> (OK=%d + NO=%d) / %dseconds = %d XHEADs / sec\n",
			ok,no,elaps,(ok+no)/elaps);
	}
}

bench(ac,av)
{	int rcode;
	char head[0x10000];
	int cnt;

	start = time(0);
	cnt = 0;

	for( anum = anum1; ;anum += inc ){
		if( b_DIRECT ){
			FILE *fp;
			if( fp = open_article(group,anum,head) ){
				bytes += strlen(head);
				fclose(fp);
				ok++;
			}else	no++;
		}else
		if( b_LINKED ){
#ifdef LIBNHC
			if( 0 < nhc_get(group,anum,head) ){
				bytes += strlen(head);
				ok++;
			}else	no++;
#else
			no++;
#endif
		}else{
			send_head_command(group,anum);
			rcode = GET_server(response,sizeof(response));

			if( *response == '2' ){
				char line[1024];

				for(;;){
					rcode = GET_server(line,sizeof(line));
					if( rcode < 0 ){
						printf("read error\n");
						exit(1);
					}
					bytes += strlen(line);
					if( line[0] == '.' && line[1] == 0 )
						break;
				}
				ok++;
			}else	no++;
		}

		if( cnt && cnt % 32 == 0 ){
			printf("*");
			if( cnt % 128 == 0 )
				printf(" ");
			fflush(stdout);
			if( cnt % 1024 == 0 )
				printf("\n");
		}
		cnt++;

		if( anum == anum2 )
			break;
	}
	printf("*");
	printf(" %3ds %4dok+%3d %8db\n", time(0)-start,ok,no, bytes);
}


STRING_ALLOC(s){ return strcpy(malloc(strlen(s)+1),s); }
mkdirr_silently(path,mode){ }
cosmos_bugreport(){ exit(1); }
news_active_first(){ return 1; }
dbg_printf(){ }
char *rstrcat(d,s) char *d; { strcpy(d,s); return d+strlen(d); }

int (*CODEC_message)();
int (*NHC_message)();
static nhc_message(fmt,a,b,c,d,e,f,g){
/*
	fprintf(stderr,fmt,a,b,c,d,e,f,g);
	fprintf(stderr,"\n");
*/
}

char *
newshead_cachedir(dir,len) char *dir; {
#ifdef XHEAD_CACHE
	strcpy(dir,XHEAD_CACHE);
	return dir;
#else
	return 0;
#endif
}
char *(*NEWSHEAD_CACHEDIR)() = newshead_cachedir;

init_nhc(){
	NHC_message = nhc_message;
	CODEC_message = nhc_message;
}

pipe_opened(){}
pipe_closed(){}
